' Description of params used in ("0000000000")
' ("1000000000") - Bold
' ("0100000000") - Italic
' ("0010000000") - Underline
' ("0001000000") - UnderlineDouble
' ("0000100000") - SuperScript
' ("0000010000") - SubScript
' ("0000001000") - AllCaps
' ("0000000100") - SmallCaps
' ("0000000010") - StrikeThrough
' ("0000000001") - DoubleStrikeThrough

Sub MakeStyle()
'
' MakeStyle Makro
'
' Created  by www.adobescripts.com - Robert Tkaczyk - 2006-08-20
' Modified by www.adobescripts.com - Robert Tkaczyk - 2013-03-07
'
' Create all allowable combinations of styles
'
   Dim process As Boolean
   
   For a1 = 0 To 1
      For a2 = 0 To 1
         For a3 = 0 To 1
            For a4 = 0 To 1
               For a5 = 0 To 1
                  For a6 = 0 To 1
                     For a7 = 0 To 1
                        For a8 = 0 To 1
                           For a9 = 0 To 1
                              For a10 = 0 To 1
                              
      process = True
      
      If a3 = 1 And a4 = 1 Then process = False
      If a5 = 1 And a6 = 1 Then process = False
      If a7 = 1 And a8 = 1 Then process = False
      If a9 = 1 And a10 = 1 Then process = False
      
      If process Then
         Call AddCharStyle(CStr(a1) & _
                           CStr(a2) & _
                           CStr(a3) & _
                           CStr(a4) & _
                           CStr(a5) & _
                           CStr(a6) & _
                           CStr(a7) & _
                           CStr(a8) & _
                           CStr(a9) & _
                           CStr(a10))
      End If
                              
                              Next a10
                           Next a9
                        Next a8
                     Next a7
                  Next a6
               Next a5
            Next a4
         Next a3
      Next a2
   Next a1
   
End Sub

Sub AddCharStyle(myParam As String)
'
' MakeStyle Makro
'
' Created  by www.adobescripts.com - Robert Tkaczyk - 2006-08-20
' Modified by www.adobescripts.com - Robert Tkaczyk - 2013-03-07
'
'
    If myParam = "0000000000" Then Exit Sub

    myName = ""
    On Error Resume Next
    ActiveDocument.Styles.Add Name:="#$Temporary$#", Type:=wdStyleTypeCharacter
    On Error GoTo 0
    With ActiveDocument.Styles("#$Temporary$#").Font
        If Mid$(myParam, 1, 1) = "1" Then
            myName = myName + " Bold"
            .Bold = True
        Else
            .Bold = False
        End If
        If Mid$(myParam, 2, 1) = "1" Then
            myName = myName + " Italic"
            .Italic = True
        Else
            .Italic = False
        End If
        If Mid$(myParam, 3, 1) = "1" Then
            myName = myName + " Underline"
            .Underline = wdUnderlineSingle
        ElseIf Mid$(myParam, 4, 1) = "1" Then
            myName = myName + " UnderlineDouble"
            .Underline = wdUnderlineDouble
        Else
            .Underline = wdUnderlineNone
        End If
        If Mid$(myParam, 5, 1) = "1" Then
            myName = myName + " SuperScript"
            .Superscript = True
        Else
            .Superscript = False
        End If
        If Mid$(myParam, 6, 1) = "1" Then
            myName = myName + " SubScript"
            .Subscript = True
        Else
            .Subscript = False
        End If
        If Mid$(myParam, 7, 1) = "1" Then
            myName = myName + " AllCaps"
            .AllCaps = True
        Else
            .AllCaps = False
        End If
        If Mid$(myParam, 8, 1) = "1" Then
            myName = myName + " SmallCaps"
            .SmallCaps = True
        Else
            .SmallCaps = False
        End If
        If Mid$(myParam, 9, 1) = "1" Then
            myName = myName + " StrikeThrough"
            .StrikeThrough = True
        Else
            .StrikeThrough = False
        End If
        If Mid$(myParam, 10, 1) = "1" Then
            myName = myName + " DoubleStrikeThrough"
            .DoubleStrikeThrough = True
        Else
            .DoubleStrikeThrough = False
        End If
        With .Shading
            .Texture = wdTextureNone
            .ForegroundPatternColor = wdColorAutomatic
            .BackgroundPatternColor = wdColorAutomatic
        End With
        .Borders(1).LineStyle = wdLineStyleNone
        .Borders.Shadow = False
    End With
    On Error Resume Next
    Err.Clear
    ActiveDocument.Styles("#$Temporary$#").NameLocal = Trim(myName)
    If Err.Number <> 0 Then
        ActiveDocument.Styles("#$Temporary$#").Delete
    End If
    On Error GoTo 0
End Sub

Sub ApplyCharStyle(myParam As String)
'
' MakeStyle Makro
'
' Created  by www.adobescripts.com - Robert Tkaczyk - 2006-08-20
' Modified by www.adobescripts.com - Robert Tkaczyk - 2013-03-07
'
'
    If myParam = "0000000000" Then Exit Sub
    
'    If Left(myParam, 2) = "10" Or Left(myParam, 2) = "01" Then Stop
    
    myName = ""
    Selection.Find.ClearFormatting
    Selection.Find.Replacement.ClearFormatting
    With Selection.Find.Font
        If Mid$(myParam, 1, 1) = "1" Then
            myName = myName + " Bold"
            .Bold = True
        Else
            .Bold = False
        End If
        If Mid$(myParam, 2, 1) = "1" Then
            myName = myName + " Italic"
            .Italic = True
        Else
            .Italic = False
        End If
        If Mid$(myParam, 3, 1) = "1" Then
            myName = myName + " Underline"
            .Underline = wdUnderlineSingle
        ElseIf Mid$(myParam, 4, 1) = "1" Then
            myName = myName + " UnderlineDouble"
            .Underline = wdUnderlineDouble
        Else
            .Underline = wdUnderlineNone
        End If
        If Mid$(myParam, 5, 1) = "1" Then
            myName = myName + " SuperScript"
            .Superscript = True
        Else
            .Superscript = False
        End If
        If Mid$(myParam, 6, 1) = "1" Then
            myName = myName + " SubScript"
            .Subscript = True
        Else
            .Subscript = False
        End If
        If Mid$(myParam, 7, 1) = "1" Then
            myName = myName + " AllCaps"
            .AllCaps = True
        Else
            .AllCaps = False
        End If
        If Mid$(myParam, 8, 1) = "1" Then
            myName = myName + " SmallCaps"
            .SmallCaps = True
        Else
            .SmallCaps = False
        End If
        If Mid$(myParam, 9, 1) = "1" Then
            myName = myName + " StrikeThrough"
            .StrikeThrough = True
        Else
            .StrikeThrough = False
        End If
        If Mid$(myParam, 10, 1) = "1" Then
            myName = myName + " DoubleStrikeThrough"
            .DoubleStrikeThrough = True
        Else
            .DoubleStrikeThrough = False
        End If
    End With
    Selection.Find.Replacement.Style = ActiveDocument.Styles(Trim(myName))
    With Selection.Find
        .Text = ""
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindContinue
        .Format = True
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
    End With
    Selection.Find.Execute Replace:=wdReplaceAll
End Sub

Sub ApplyStyle()
'
' MakeStyle Makro
'
' Created  by www.adobescripts.com - Robert Tkaczyk - 2006-08-20
' Modified by www.adobescripts.com - Robert Tkaczyk - 2013-03-07
'
' Apply all allowable combinations of styles
'
    
   Dim process As Boolean
   
   For a1 = 0 To 1
      For a2 = 0 To 1
         For a3 = 0 To 1
            For a4 = 0 To 1
               For a5 = 0 To 1
                  For a6 = 0 To 1
                     For a7 = 0 To 1
                        For a8 = 0 To 1
                           For a9 = 0 To 1
                              For a10 = 0 To 1
                              
      process = True
      
      If a3 = 1 And a4 = 1 Then process = False
      If a5 = 1 And a6 = 1 Then process = False
      If a7 = 1 And a8 = 1 Then process = False
      If a9 = 1 And a10 = 1 Then process = False
      
      If process Then
         Call ApplyCharStyle(CStr(a1) & _
                             CStr(a2) & _
                             CStr(a3) & _
                             CStr(a4) & _
                             CStr(a5) & _
                             CStr(a6) & _
                             CStr(a7) & _
                             CStr(a8) & _
                             CStr(a9) & _
                             CStr(a10))
      End If
                              
                              Next a10
                           Next a9
                        Next a8
                     Next a7
                  Next a6
               Next a5
            Next a4
         Next a3
      Next a2
   Next a1
   
End Sub